#pragma once
#ifndef ROGUE_H
#define ROGUE_H

#include <stdio.h>
#include <conio.h>
#include <fstream>
#include <math.h>

#include "stools.h"

using namespace std;

typedef int tshadow[80][25];

struct tcell
{
	int type,pics;
	char* name;
	tsym pic[8];
};

typedef struct tcell tcell;

struct tlevel
{
	int w,h;
	char* name;
	int cell[80][25];
};

typedef struct tlevel tlevel;

struct tobject
{
	int x,y,l,type,parent,pics;
	char* name;
	tsym pic[8];
};

typedef struct tobject tobject;

struct titem
{
	int x,y,l,val,type,parent;
	char* name;
	tsym pic;
};

typedef struct titem titem;

struct tchar
{
	int x,y,l,speed,time,player,type,money,parent;
	char* name;
	tsym pic;
};

typedef struct tchar tchar;

/////
struct thero
{
   int x,y;
   char symb;
};
 
typedef struct thero thero;
/////

//typedef tcell tflor[80][25];

//typedef tflor tlevel;

struct tgame
{
	tlevel level[10];
	
	tcell cell[100];
	
	tobject pobject[10];
	tobject object[1000];
	
	titem pitem[10];
	titem item[100];
	
	tchar pcar[10];
	tchar car[100];
	
	int otable[10][80][25];
	int ctable[10][80][25];
	int itable[10][80][25]; 
	
	int objects,items,chars,end;
	unsigned long int time;
};

typedef tgame tgame;

bool game_set(tgame &game);
bool game_draw(tgame game, int cadr, int l, bool putshadow);
bool game_ai(tgame &game, int l);
int game_get_objectidxy(tgame game, int x, int y, int l);
int game_get_itemidxy(tgame game, int x, int y, int l);
int game_get_charidxy(tgame game, int x, int y, int l);
bool game_remove_item(tgame &game, int id);
bool game_set_tables(tgame &game);

bool game_draw(tgame game, int cadr, int l, bool putshadow)
{
	int row = game.level[l].h; 
 	int col = game.level[l].w;
	int c,co,attr,ix,iy,cx,cy,i,j;
	bool shadow[80][25];
	float s,dx,dy,ddx,ddy,lx,ly,dd=0.3;
	 
	
	if(l<0 || l>9) return false;
 
	CHAR_INFO consBuffer[2000];
	
	
	for (j = 0; j<25; j++)
		for (i=0; i<80; i++)  
		{ 
			consBuffer[i+j*80].Char.UnicodeChar = 0; 
			consBuffer[i+j*80].Attributes = 0;
			shadow[i][j]=true;			
		}
	
	if(putshadow)
	{
		cx=game.car[0].x;
		cy=game.car[0].y;
		for (j=0; j<25; j++)
		for (i=0; i<80; i++)  
		{			
			if(i!=game.car[0].x && j!=game.car[0].y)
			{	
				for(int n=1; n<=4; n++)
				{
					if(n==1)
					{
						dx=i-cx-0.5;
						dy=j-cy-0.5;
					}
					if(n==2)
					{
						dx=i-cx+0.5;
						dy=j-cy-0.5;
					}
					if(n==3)
					{
						dx=i-cx-0.5;
						dy=j-cy+0.5;
					}
					if(n==4)
					{
						dx=i-cx+0.5;
						dy=j-cy+0.5;
					}
				
					s=pow((dx*dx+dy*dy),0.5);
					lx=0; ly=0;
					if(s>0)
					{
						
						ddx=dx*dd/s;
						ddy=dy*dd/s;
						ix=cx; iy=cy;
						//point a ray
						do{
							lx+=ddx; ly+=ddy;
							ix=cx+floor(lx+0.5); iy=cy+floor(ly+0.5);
							if(fabs(lx)>=fabs(dx) || fabs(ly)>=fabs(dy)) shadow[i][j]=false;				
						}while(ix>=0 && iy>=0 && ix<=col && iy<=row && fabs(lx)<fabs(dx) && fabs(ly)<fabs(dy) && game.otable[l][ix][iy]==-1 && game.ctable[l][ix][iy]<=0);
					}
				}
			} else shadow[i][j]=false;
		}		
	}
	
	for (j = 0; j<row; j++)
		for (i=0; i<col; i++)  
		{ 
			if(putshadow==false || shadow[i][j]==false)
			{
			c=cadr;
			if(cadr>0)
				c = cadr%game.cell[game.level[l].cell[i][j]].pics;
			consBuffer[i+j*80].Char.UnicodeChar = game.cell[game.level[l].cell[i][j]].pic[c].s; 
			consBuffer[i+j*80].Attributes = game.cell[game.level[l].cell[i][j]].pic[c].attr;
			}
		}
		
		
	for(i=0; i<game.objects; i++)
	{
		if((game.object[i].l==l) && (putshadow==false || shadow[game.object[i].x][game.object[i].y]==false))
		{
		co=cadr;
		c=cadr;
		if(cadr>0)
		{
			co = cadr%game.object[i].pics;
			c = cadr%game.cell[game.level[l].cell[game.object[i].x][game.object[i].y]].pics;
		}
		consBuffer[game.object[i].x+game.object[i].y*80].Char.UnicodeChar = game.object[i].pic[co].s; 
		if(game.object[i].pic[c].attr<16 && game.cell[game.level[l].cell[game.object[i].x][game.object[i].y]].pic[c].attr>15)
			attr = game.object[i].pic[c].attr+16*(int)(game.cell[game.level[l].cell[game.object[i].x][game.object[i].y]].pic[c].attr/16);
		else
			attr = game.object[i].pic[c].attr;
		consBuffer[game.object[i].x+game.object[i].y*80].Attributes = attr;
		}
	}
	
	for(i=0; i<game.items; i++)
	{				
		if((game.item[i].l==l) && (!putshadow || !shadow[game.item[i].x][game.item[i].y]))
		{
		c=cadr;
		if(cadr>0)
		{
			c = cadr%game.cell[game.level[l].cell[game.item[i].x][game.item[i].y]].pics;
		}
		consBuffer[game.item[i].x+game.item[i].y*80].Char.UnicodeChar = game.item[i].pic.s; 
		if(game.item[i].pic.attr<16 && game.cell[game.level[l].cell[game.item[i].x][game.item[i].y]].pic[c].attr>15)
			attr = game.item[i].pic.attr+16*(int)(game.cell[game.level[l].cell[game.item[i].x][game.item[i].y]].pic[c].attr/16);
		else
			attr = game.item[i].pic.attr;
		consBuffer[game.item[i].x+game.item[i].y*80].Attributes = attr;
		}
	}
	
	for(i=0; i<game.chars; i++)
	{				
		if((game.car[i].l==l) && (!putshadow || !shadow[game.car[i].x][game.car[i].y]))
		{
		c=cadr;
		if(cadr>0)
		{
			c = cadr%game.cell[game.level[l].cell[game.car[i].x][game.car[i].y]].pics;
		}
		consBuffer[game.car[i].x+game.car[i].y*80].Char.UnicodeChar = game.car[i].pic.s; 
		if(game.car[i].pic.attr<16 && game.cell[game.level[l].cell[game.car[i].x][game.car[i].y]].pic[c].attr>15)
			attr = game.car[i].pic.attr+16*(int)(game.cell[game.level[l].cell[game.car[i].x][game.car[i].y]].pic[c].attr/16);
		else
			attr = game.car[i].pic.attr;
		consBuffer[game.car[i].x+game.car[i].y*80].Attributes = attr;
		}
	}
	
	
	SMALL_RECT writeArea={0,0,col-1,row-1}; 
	BufferOut(consBuffer, writeArea);
	return true;
}

int game_get_objectidxy(tgame game, int x, int y, int l)
{
	for(int i=0; i<game.objects; i++)
		if(game.object[i].x==x && game.object[i].y==y && game.object[i].l==l && i<1000) return i;
	return -1;
}

int game_get_itemidxy(tgame game, int x, int y, int l)
{
	for(int i=0; i<game.items; i++)
		if(game.item[i].x==x && game.item[i].y==y && game.item[i].l==l && i<1000) return i;
	return -1;
}

int game_get_charidxy(tgame game, int x, int y, int l)
{
	for(int i=0; i<game.chars; i++)
		if(game.car[i].x==x && game.car[i].y==y && game.car[i].l==l && i<1000) return i;
	return -1;
}

bool game_remove_item(tgame &game, int id)
{
	if(id>game.items-1 || id<0) return false;
	
	game.itable[game.item[id].l][game.item[id].x][game.item[id].y]=-1;
	
	if(id==game.items-1) {
		game.items--;
		return true;
	}	
	
	for(int i=id; i<game.items-1; i++)
	{
		game.item[i]=game.item[i+1];
	}
	game.items--;
	
	return true;
}

bool game_set(tgame &game)
{
	int i,j;
	game.time=0;
	game.end = 0;
	//ground
	i=0;//0
	
	game.level[0].w=60;
	game.level[0].h=25;
	
	game.cell[i].name="ground";
	game.cell[i].type=1;
	game.cell[i].pics=1;
	game.cell[i].pic[0].s=249;
	game.cell[i].pic[0].attr=6;
	
	i++;//1
	game.cell[i].name="water";
	game.cell[i].type=2;
	game.cell[i].pics=3;
	game.cell[i].pic[0].s=176;
	game.cell[i].pic[0].attr=11;
	game.cell[i].pic[1].s=177;
	game.cell[i].pic[1].attr=11;
	game.cell[i].pic[2].s=178;
	game.cell[i].pic[2].attr=11;
	
	i++;//2 =
	game.cell[i].name="bridge";
	game.cell[i].type=1;
	game.cell[i].pics=1;
	game.cell[i].pic[0].s=61;
	game.cell[i].pic[0].attr=6*16+7;
	
	i++;//3 ||
	game.cell[i].name="bridge";
	game.cell[i].type=1;
	game.cell[i].pics=1;
	game.cell[i].pic[0].s=186;
	game.cell[i].pic[0].attr=6*16+7;
	
	for(i=0; i<60; i++)
		for(j=0; j<25; j++)
			game.level[0].cell[i][j] = 0;
	
	for(i=1; i<11; i++) game.level[0].cell[13][i] = 1;
	for(i=11; i<24; i++) game.level[0].cell[38][i] = 1;
	for(i=13; i<38; i++) game.level[0].cell[i][11] = 1;
	
	game.level[0].cell[13][7] = 2;
	game.level[0].cell[38][20] = 2;
	game.level[0].cell[25][11] = 3;
	
	//objects
	i=0;
	game.pobject[i].name="ground wall";
	game.pobject[i].x=0;
	game.pobject[i].y=0;
	game.pobject[i].l=0;
	game.pobject[i].parent=0;
	game.pobject[i].type=1;
	game.pobject[i].pics=1;
	game.pobject[i].pic[0].s=219;
	game.pobject[i].pic[0].attr=6;
	game.pobject[i].parent=-1;
	
	i++;
	game.pobject[i].name="stone wall";
	game.pobject[i].x=0;
	game.pobject[i].y=0;
	game.pobject[i].l=0;
	game.pobject[i].parent=0;
	game.pobject[i].type=1;
	game.pobject[i].pics=1;
	game.pobject[i].pic[0].s=219;
	game.pobject[i].pic[0].attr=7;
	game.pobject[i].parent=-1;
	
	game.objects=0;
	
	for(i=0; i<60; i++)
	{
	game.object[game.objects]=game.pobject[0];
	game.object[game.objects].parent=0;
	game.object[game.objects].x=i;
	game.object[game.objects].y=0;
	game.objects++;
	
	game.object[game.objects]=game.pobject[0];
	game.object[game.objects].parent=0;
	game.object[game.objects].x=i;
	game.object[game.objects].y=24;
	game.objects++;
	}
	
	for(i=1; i<24; i++)
	{
	game.object[game.objects]=game.pobject[0];
	game.object[game.objects].parent=0;
	game.object[game.objects].x=0;
	game.object[game.objects].y=i;
	game.objects++;
	
	game.object[game.objects]=game.pobject[0];
	game.object[game.objects].parent=0;
	game.object[game.objects].x=59;
	game.object[game.objects].y=i;
	game.objects++;
	}
	
	//items
	
	i=0;
	game.pitem[i].name="gold";
	game.pitem[i].type=1;
	game.pitem[i].val=1;
	game.pitem[i].pic.s='$';
	game.pitem[i].pic.attr=14;
	
	game.items=0;		
	game.item[game.items]=game.pitem[0];
	game.item[game.items].x=3;
	game.item[game.items].y=3;
	game.item[game.items].l=0;	
	game.items++;
	
	//chars
	i=0;
	game.pcar[i].name="dweller";
	game.pcar[i].x=0;
	game.pcar[i].y=0;
	game.pcar[i].l=0;
	game.pcar[i].speed=500;
	game.pcar[i].time=0;
	game.pcar[i].type=0;
	game.pcar[i].money=0;
	game.pcar[i].player=1;
	game.pcar[i].pic.s=64;
	game.pcar[i].pic.attr=11;
	game.pcar[i].parent=-1;
	
	i++;
	game.pcar[i].name="salamander";
	game.pcar[i].x=0;
	game.pcar[i].y=0;
	game.pcar[i].l=0;
	game.pcar[i].speed=1000;
	game.pcar[i].time=0;
	game.pcar[i].type=1;
	game.pcar[i].money=0;
	game.pcar[i].player=0;
	game.pcar[i].pic.s=244;
	game.pcar[i].pic.attr=2;
	game.pcar[i].parent=-1;
	
	game.chars=0;
	game.car[game.chars]=game.pcar[0];
	game.car[game.chars].parent=0;
	game.car[game.chars].x=1;
	game.car[game.chars].y=1;
	game.chars++;
	
	game.car[game.chars]=game.pcar[1];
	game.car[game.chars].parent=1;
	game.car[game.chars].x=55;
	game.car[game.chars].y=22;
	game.chars++;			
	
	game_set_tables(game);	
		
	return true;
}

bool game_set_tables(tgame &game)
{
	int i;
	for(int k=0; k<10; k++)
		for(int i=0; i<80; i++)
			for(int j=0; j<25; j++)
			{
				game.otable[k][i][j]=-1;
				game.ctable[k][i][j]=-1;
				game.itable[k][i][j]=-1;
			}
	
	for(i=0; i<game.objects; i++)
	{
		game.otable[game.object[i].l][game.object[i].x][game.object[i].y] = i;
	}
	
	for(i=0; i<game.chars; i++)
	{
		game.ctable[game.car[i].l][game.car[i].x][game.car[i].y] = i;
	}
	
	for(i=0; i<game.items; i++)
	{
		game.itable[game.item[i].l][game.item[i].x][game.item[i].y] = i;
	}
	
	return true;
}

bool game_ai(tgame &game, int l)
{
	int dx=0, dy=0,x,y,d,done=0,i;
	float s;
	
	for(i=1; i<game.chars; i++)
	{
		done=0;
		if(game.car[i].l==l && game.car[i].time<game.time)
		{
			x=game.car[i].x; y=game.car[i].y;
			//choose path
			if((x-game.car[0].x==0  && abs(y-game.car[0].y)==1) 
			||(y-game.car[0].y==0  && abs(x-game.car[0].x)==1)){
				game.end=1;
				return true;
			}
			
			if(abs(x-game.car[0].x)==1 && abs(y-game.car[0].y)==1)
			{
				d=rand()%2+1;
				if(d==1) dx=game.car[0].x-x; else dy=game.car[0].y-y;
				
				if(game_get_objectidxy(game,x+dx,y+dy,l)==-1
				&& game_get_charidxy(game,x+dx,y+dy,l)==-1
				&& game.cell[game.level[l].cell[x+dx][y+dy]].type==1)
				{
					game.ctable[l][game.car[i].x][game.car[i].y]=-1;
					game.car[i].x=game.car[0].x;
					game.ctable[l][game.car[i].x][game.car[i].y]=i;					
					game.car[i].time=game.time+game.car[i].speed;
					done=1;
				}
				
				if(dx!=0) {dx=0; dy=game.car[0].y-y;}
				else {dy=0; dx=game.car[0].x-x;}
				
				if(game_get_objectidxy(game,x+dx,y+dy,l)==-1
				&& game_get_charidxy(game,x+dx,y+dy,l)==-1
				&& game.cell[game.level[l].cell[x+dx][y+dy]].type==1
				&& done==0)
				{
					game.ctable[l][game.car[i].x][game.car[i].y]=-1;
					game.car[i].x=game.car[0].x;
					game.ctable[l][game.car[i].x][game.car[i].y]=i;
					game.car[i].time=game.time+game.car[i].speed;
					done=1;
				}
				
				game.car[i].time=game.time+game.car[i].speed;
			}
			
			d=rand()%4+1;
			if(d==1){dx=0; dy=-1;}
			if(d==2){dx=-1; dy=0;}
			if(d==3){dx=0; dy=1;}
			if(d==4){dx=1; dy=0;}
			if(game_get_objectidxy(game,x+dx,y+dy,l)==-1
			&& game_get_charidxy(game,x+dx,y+dy,l)==-1
			&& game.cell[game.level[l].cell[x+dx][y+dy]].type==1
			&& done==0)
			{
				game.ctable[l][game.car[i].x][game.car[i].y]=-1;
				game.car[i].x+=dx;
				game.car[i].y+=dy;
				game.ctable[l][game.car[i].x][game.car[i].y]=i;
				game.car[i].time=game.time+game.car[i].speed;
				done=1;
			}
		}
	}
	
	return true;
}
#endif
